package database;


/** @Author: Inder Mohan Singh
  * @Project Name:  Database
  * Number of Files: 1
  * Files Name: Database.java
  *
  *
  *
  * Code provided by Author Inder Mohan Singh (http://www.geocities.com/imsb69) 'as is',
  * without warranties as to performance, fitness, <br>merchantability,and any other warranty
  * (whether expressed or implied ).Terms of Agreement: By using this source code, you agree
  * to the following terms...
  *   1) You may use this source code in personal projects and may compile it into an
  *	    .exe/.dll/.ocx/jar and distribute it in binary format freely and with no charge.
  *   2) You MAY NOT redistribute this source code (for example to a web site) without
  *	    written permission from the original author.Failure to do so is a violation of copyright
  *	    laws.
  *   3) You may link to this code from another website, provided it is not wrapped in a frame.
  *
  *	If you find any bug in this source codes please e-mail imsb69@yahoo.com
  *

 */






import javax.swing.JTabbedPane;
import javax.swing.ImageIcon;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JFrame;
import javax.swing.JButton;

import java.awt.*;
import java.awt.event.*;
import java.awt.print.*;
import java.sql.*;
import java.io.*;


/**
 * Title:        Database Application
 * Description:  This program will make interface for manipulating database of employee using Jdbc and Odbc and Microsoft Access drivers.
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Inder Mohan Singh
 * @version 1.0
 */

public class DatabaseApp extends JPanel {

   // declare the width and height of UI

  public static int WIDTH = 600;
  public static int HEIGHT = 500;

  // create  textfield objects for user to enter the input
  TextField employeeID = new TextField(15);
  TextField name = new TextField(40);
  TextField address = new TextField(40);
  TextField suburb = new TextField(20);
  TextField state = new TextField(5);
  TextField pCode = new TextField(5);
  TextField dob = new TextField(15);
  TextField homePh = new TextField(15);
  TextField workPh = new TextField(15);
  TextField mobile = new TextField("0",15);
  TextField eMail = new TextField(30);
  TextField dbase = new TextField("employee",20);
  TextField report = new TextField(15);
  TextField query= new TextField(50);
  TextArea displayArea = new TextArea(16,80);
  TextArea helpArea = new TextArea(20,80);
  /** add buttons to the  database form
      public JButton(String text,Icon icon)
                    Creates a button with initial text and an icon.
                    Parameters:
                                text - the text of the button.
                                icon - the Icon image to display on the button

    */

  JButton newButton = new JButton (" New ", new ImageIcon(database.DatabaseApp.class.getResource("New.gif")));
  JButton addButton = new JButton (" Add ", new ImageIcon (database.DatabaseApp.class.getResource("Add.gif")));
  JButton findButton = new JButton (" Retrieve ", new ImageIcon (database.DatabaseApp.class.getResource("Find.gif")));
  JButton updateButton = new JButton (" Update ", new ImageIcon (database.DatabaseApp.class.getResource("Refresh.gif")));
  JButton deleteButton = new JButton (" Delete ", new ImageIcon (database.DatabaseApp.class.getResource("Delete.gif")));
  JButton submitButton = new JButton (" Submit Query ", new ImageIcon (database.DatabaseApp.class.getResource("Export.gif")));
  JButton reportButton = new JButton (" Report File ", new ImageIcon (database.DatabaseApp.class.getResource("AlignLeft.gif")));

  /** create tabbed pane for form
   *   public void addTab(String title,Icon icon,Component component,String tip)
   *   Parameters:
   *               title - the title to be displayed in this tab
   *               icon - the icon to be displayed in this tab
   *               component - The component to be displayed when this tab is clicked.
   *               tip - the tooltip to be displayed for this tab
   */


  public DatabaseApp() {
    // create new tabbedPane object
    JTabbedPane tabbedPane = new JTabbedPane();

    tabbedPane.addTab(" General ",null, buildGeneralPanel(), "General");
    tabbedPane.addTab(" Queries ",null, buildQueryPanel(), "General");

    tabbedPane.addTab(" Author ",null, buildAuthorPanel(), "General");


    // assign layout manager
    setLayout(new GridLayout(1,1));
    add(tabbedPane);

  }

  /**Create a JPanel for General tab, divide it into three JPanels for label, displaytext
   * and buttons.Assign a Flowlayout manager to each panel. Add label, textfield
   * and buttons to respective panel. following constructors will be used
   * for Jlabel
   * public JLabel(String text)
   * Creates a JLabel instance with the specified text. The label is aligned against the leading edge of its display area, and centered vertically.
   *            Parameters:
   *                       text - The text to be displayed by the label.

   */

    protected Component buildGeneralPanel() {
      // main panel
      JPanel mainPanel = new JPanel();
      // divided into three panes. these panes will be added to mainPanel
      JPanel westPane = new JPanel();
      JPanel centrePane = new JPanel();
      JPanel southPane = new JPanel();

      // assign the layout managers
      mainPanel.setLayout(new BorderLayout());
      westPane.setLayout(new GridLayout(12,1));
      centrePane.setLayout(new GridLayout(12,1));

      // create array of Panels for label textfield and buttons and make them left align
      Panel labelPane[] = new Panel[12];
      Panel textPane[] = new Panel[12];
      Panel buttonPane[] = new Panel[2];

      for (int i=0; i < labelPane.length; ++i) {
        labelPane[i] = new Panel();
        labelPane[i].setLayout(new FlowLayout(FlowLayout.LEFT));
      }

      for (int i=0; i < textPane.length; ++i) {
        textPane[i] = new Panel();
        textPane[i].setLayout(new FlowLayout(FlowLayout.LEFT));
      }

      for (int i=0; i < buttonPane.length; ++i) {
        buttonPane[i] = new Panel();
        buttonPane[i].setLayout(new FlowLayout(FlowLayout.LEFT));
      }


      // add different label to the labelPane

      labelPane[0].add(new JLabel("Employee No"));
      labelPane[1].add(new JLabel("Name"));
      labelPane[2].add(new JLabel("Address"));
      labelPane[3].add(new JLabel("Suburb"));
      labelPane[4].add(new JLabel("State"));
      labelPane[5].add(new JLabel("PostCode"));
      labelPane[6].add(new JLabel("Date of Birth"));
      labelPane[7].add(new JLabel("Home Phone"));
      labelPane[8].add(new JLabel("Work Phone"));
      labelPane[9].add(new JLabel("Mobile"));
      labelPane[10].add(new JLabel("E-mail"));


      // add textfield component to textPane
      textPane[0].add(employeeID);
      textPane[1].add(name);
      textPane[2].add(address);
      textPane[3].add(suburb);
      textPane[4].add(state);
      textPane[5].add(pCode);
      textPane[6].add(dob);
      textPane[7].add(homePh);
      textPane[8].add(workPh);
      textPane[9].add(mobile);
      textPane[10].add(eMail);

      // add button to buttonPane and assign keyboard key for shortcut e.g Alt + n

      buttonPane[0].add(newButton);
      newButton.setMnemonic('n');

      buttonPane[0].add(addButton);
      addButton.setMnemonic('a');
      buttonPane[0].add(findButton);
      findButton.setMnemonic('r');
      buttonPane[0].add(updateButton);
      updateButton.setMnemonic('u');
      buttonPane[0].add(deleteButton);
      deleteButton.setMnemonic('d');

      // add actionlistener to the buttons

      newButton.addActionListener(new ButtonHandler());
      addButton.addActionListener(new ButtonHandler());
      findButton.addActionListener(new ButtonHandler());
      updateButton.addActionListener(new ButtonHandler());
      deleteButton.addActionListener(new ButtonHandler());

      for (int i = 0; i < labelPane.length; ++i)
          westPane.add(labelPane[i]);
      for (int i = 0; i < textPane.length; ++i)
          centrePane.add(textPane[i]);
      for (int i = 0; i < buttonPane.length; ++i)
          southPane.add(buttonPane[i]);

      mainPanel.add(westPane,BorderLayout.WEST);
      mainPanel.add(centrePane,BorderLayout.CENTER);
      mainPanel.add(southPane,BorderLayout.SOUTH);

      return mainPanel;
    }

    protected JPanel buildQueryPanel() {
        JPanel mainPane = new JPanel();

        // divided into three panes. these panes will be added to mainPanel
      JPanel westPane = new JPanel();
      JPanel centrePane = new JPanel();
      JPanel southPane = new JPanel();


      // assign the layout managers
       mainPane.setLayout(new BorderLayout());
      westPane.setLayout(new GridLayout(4,1));
      centrePane.setLayout(new GridLayout(4,1));

      // create array of Panels for label textfield and buttons and make them left align
      Panel labelPane[] = new Panel[4];
      Panel buttontxtPane[] = new Panel[4];
      Panel textPane[] = new Panel[1];


      for (int i=0; i < labelPane.length; ++i) {
        labelPane[i] = new Panel();
        labelPane[i].setLayout(new FlowLayout(FlowLayout.LEFT));
      }

      for (int i=0; i < buttontxtPane.length; ++i) {
        buttontxtPane[i] = new Panel();
        buttontxtPane[i].setLayout(new FlowLayout(FlowLayout.LEFT));
      }
      for (int i=0; i < textPane.length; ++i) {
        textPane[i] = new Panel();
        textPane[i].setLayout(new FlowLayout(FlowLayout.LEFT));
      }



      // add different label to the labelPane

      labelPane[0].add(new JLabel("Database:"));
      labelPane[1].add(new JLabel("Query:"));
      labelPane[2].add(new JLabel("Report File:"));
      labelPane[3].add(new Label(""));
      // textfields
      buttontxtPane[0].add(dbase);
      buttontxtPane[1].add(query);
      buttontxtPane[2].add(report);
      // buttons
      buttontxtPane[3].add(submitButton);
      submitButton.setMnemonic('s');
      buttontxtPane[3].add(reportButton);
      reportButton.setMnemonic('r');

      // text area to view the result
      textPane[0].add(displayArea);

      // add action listener to buttons
      submitButton.addActionListener(new ButtonHandler());
      reportButton.addActionListener(new ButtonHandler());

      for(int i=0; i < labelPane.length; ++i)
        westPane.add(labelPane[i]);
      for(int i=0; i < buttontxtPane.length; ++i)
        centrePane.add(buttontxtPane[i]);
      for(int i=0; i < textPane.length; ++i)
        southPane.add(textPane[i]);


      mainPane.add(westPane, BorderLayout.WEST);
      mainPane.add(centrePane, BorderLayout.CENTER);
      mainPane.add(southPane,BorderLayout.SOUTH);
      return mainPane;
    }

    protected JPanel buildAuthorPanel(){
        JPanel authorPanel = new JPanel();
        JPanel authorPane = new JPanel();

        authorPanel.setLayout(new BorderLayout());
        authorPane.setLayout(new GridLayout(9,1));
        Panel pane[] = new Panel[9];

        for (int i=0; i < pane.length; i++) {
            pane[i] = new Panel();
            pane[i].setLayout(new FlowLayout(FlowLayout.CENTER));
        }

        pane[0].add(new JLabel(""));
        pane[1].add(new JLabel(""));
        pane[2].add(new JLabel(""));
        pane[3].add(new JLabel(""));
        pane[4].add(new JLabel("Inder Mohan Singh"));
        pane[5].add(new JLabel("E-mail: imsb69@yahoo.com"));
        pane[6].add(new JLabel(""));
        pane[7].add(new JLabel(""));
        pane[8].add(new JLabel(""));


        for (int i=0; i < pane.length; i++)
            authorPane.add(pane[i]);

            authorPanel.add(authorPane, BorderLayout.CENTER);
        return authorPanel;
    }


    class ButtonHandler implements ActionListener {
        public void actionPerformed(ActionEvent event) {
            String s = event.getActionCommand();
            if(s == " New ")
                // call this function
                newInput("");
            else if (s == " Submit Query ")
                // call this function
                queryDatabase();
            else if (s == " Report File ")
                report();
            else
                updateDatabase(s);
        }
   }

   void newInput (String s) {
    employeeID.setText("");
    name.setText("");
    address.setText("");
    suburb.setText("");
    state.setText("");
    pCode.setText("");
    dob.setText("");
    homePh.setText("");
    workPh.setText("");
    mobile.setText("");
    eMail.setText("");
  }


  void updateDatabase (String s) {
    String cmmd = s;
    String sql = "";
    try{
            String url = "jdbc:odbc:employee";
            String username = "";
            String password = "";
            try {
                    Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
            } catch (Exception e) {
                    System.out.println("Failed to load JDBC/ODBC driver.");
               return;
            }
            Connection con = DriverManager.getConnection(url, username, password);
            Statement stmt = con.createStatement();

            if(cmmd == " Add "){
                sql = "INSERT INTO empdetails VALUES ('"+employeeID.getText()+"'";
                    sql +=",'"+name.getText()+"'";
                    sql +=",'"+address.getText()+"'";
                    sql +=",'"+suburb.getText()+"'";
                    sql +=",'"+state.getText()+"'";
                    sql +=",'"+pCode.getText()+"'";
                    sql +=",'"+dob.getText()+"'";
                    sql +=",'"+homePh.getText()+"'";
                    sql +=",'"+workPh.getText()+"'";
                    sql +=",'"+mobile.getText()+"'";
                    sql +=",'"+eMail.getText()+"'";
                    sql +=")";
            }
            if (cmmd == " Retrieve "){
                sql = "SELECT * from empdetails where employeeID = ('"+employeeID.getText()+"')";
                ResultSet rs = stmt.executeQuery(sql);
                try {
                        if(rs.next()) {
                            name.setText(rs.getString(2));
                            address.setText(rs.getString(3));
                            suburb.setText(rs.getString(4));
                            state.setText(rs.getString(5));
                            pCode.setText(rs.getString(6));
                            dob.setText(rs.getString(7));
                            homePh.setText(rs.getString(8));
                            workPh.setText(rs.getString(9));
                            mobile.setText(rs.getString(10));
                            eMail.setText(rs.getString(11));
                            rs.close();
                        }
                        else {
                                newInput("No Record Found");
                                rs.close();
                            }
                }catch(SQLException e){}
            }
            if(cmmd == " Update ") {
                sql = "UPDATE empdetails set name = '"+name.getText()+"'";
                sql +=",address = '"+address.getText()+"'";
                sql +=",suburb = '"+suburb.getText()+"'";
                sql +=",state = '"+state.getText()+"'";
                sql +=",pCode = '"+pCode.getText()+"'";
                sql +=",homePh = '"+homePh.getText()+"'";
                sql +=",workPh = '"+workPh.getText()+"'";
                sql +=",mobile = '"+mobile.getText()+"'";
                sql +=",email = '"+eMail.getText()+"'";
                sql +=" where employeeID = '"+employeeID.getText()+"'";
            }

            if (cmmd == " Delete ") {
                sql ="DELETE * from empdetails where employeeID = ('"+employeeID.getText()+"')";
                newInput("");
            }
            stmt.executeUpdate(sql);
            con.close();
            } catch(Exception ex) {
                System.out.println(ex.toString());
              }
    }

    void queryDatabase(){
        try {
                String url ="jdbc:odbc:" + dbase.getText();
                String user ="";
                String passwd = "";

                Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
                Connection con = DriverManager.getConnection(url, user, passwd);
                Statement statement = con.createStatement();
                boolean hasResult = statement.execute(query.getText());

                if (hasResult) {
                    ResultSet result = statement.getResultSet();
                    if(result != null)
                        displayResults(result);
                }
                else
                    displayArea.setText("");
                    con.close();
        } catch (Exception ex) {
                displayArea.setText(ex.toString());
           }
    }

    void displayResults(ResultSet r) throws SQLException {
        ResultSetMetaData rmeta = r.getMetaData();
        int numColumns = rmeta.getColumnCount();
        String text =" ";
        for(int i=1; i <= numColumns; ++i){
            if (i < numColumns)
                text += rmeta.getColumnName(i)+" | ";
            else
                text += rmeta.getColumnName(i);
        }
        text +="\n";
        while(r.next()) {
            for(int i=1; i <= numColumns; ++i) {
                  if (i < numColumns)
                    text += r.getString(i)+" | ";
                  else
                    text += r.getString(i).trim();
            }
            text += "\n";
        }
        displayArea.setText(text);
    }

    void report() {
        String output = " ";
        try {
                output = report.getText();
                FileOutputStream fos = new FileOutputStream(output);
                ObjectOutputStream oos = new  ObjectOutputStream(fos);
                oos.writeObject(displayArea.getText());
                oos.flush();
                fos.close();
        } catch(Throwable e) {
            System.out.println(e);
        }
    }

    public static void main (String[] args) {
        JFrame frame = new JFrame ("Database Application");
        frame.addWindowListener(new WindowAdapter(){
            public void windowClosing (WindowEvent e) {
                    System.exit(0);
            }
        });
        frame.getContentPane().add(new DatabaseApp(), BorderLayout.CENTER);
        frame.setSize(600,500);
        frame.setVisible(true);
   }

}